/* Imports for JNI loader (see '%pragma(java) jniclasscode' block below). */
%pragma(java) jniclassimports = %{
	import java.net.URL;
	import java.util.zip.ZipFile;
	import java.io.File;
	import java.io.FileOutputStream;
	import java.io.InputStream;
%}

%pragma(java) jniclasscode = %{
	/* Load JNI library from JAR.
	 * Inspired by http://tlrobinson.net/blog/2009/03/09/embedding-and-loading-a-jni-library-from-a-jar/
	 */
	static {
		try {
			// get the class object for this class, and get the location of it
			final Class c = $moduleJNI.class;
			final URL location = c.getProtectionDomain().getCodeSource().getLocation();

			// jars are just zip files, get the input stream for the lib
			ZipFile zf = new ZipFile(location.getPath());
			InputStream in = zf.getInputStream(zf.getEntry("lib$moduleJNI.so"));

			// create a temp file and an input stream for it
			File f = File.createTempFile("JARLIB-", "-lib$moduleJNI.so");
			FileOutputStream out = new FileOutputStream(f);

			// copy the lib to the temp file
			byte[] buf = new byte[1024];
			int len;
			while ((len = in.read(buf)) > 0)
				out.write(buf, 0, len);
			in.close();
			out.close();

			// load the lib specified by it’s absolute path and delete it
			System.load(f.getAbsolutePath());
			f.delete();

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
%}
